{% extends '../base.html'%}
{% block main %}
{% load static %}
<style>
  .all-others .all-others-section {
    display: none;
    transition: opacity 1s ease-out;
    opacity: 0;
  }
  .all-others .all-others-section.active {
    opacity: 1;
    display: block;
  }
</style><div class="conatiner-all d-flex position-relative">
  {% include "../components/quick_access.html" %}
  {% include "./admin-aside.html" %}
  <div class="table-container">
    <div class="all-others mb-4">
      {% csrf_token %}
      <div
        class="d-flex justify-content-center align-content-center gap-3 flex-wrap my-3"
      >
        <button
          type="button"
          id="btnGoToTags"
          onclick="changeCurrentSection(this)"
          data-gole="1"
          class="normal-btn text-white text-center px-2 py-1 shadow rounded bg-primary"
        >
          Tags
        </button>
        <button
          type="button"
          id="btnGoToTypes"
          onclick="changeCurrentSection(this)"
          data-gole="2"
          class="normal-btn text-white text-center px-2 py-1 shadow rounded bg-secondary"
        >
          Types
        </button>
        <button
          type="button"
          id="btnGoToCompanies"
          onclick="changeCurrentSection(this)"
          data-gole="3"
          class="normal-btn text-white text-center px-2 py-1 shadow rounded bg-secondary"
        >
          Entreprises
        </button>
      </div>
      <section id="tags-section" class="all-others-section tags active">
        <p class="text-center fs-4 mt-3">Liste des tags</p>
        <div class="sort">
          <div class="search">
            <div class="input-group">
              <input
                placeholder="Recharcher ..."
                type="text"
                class="form-control px-2"
                aria-label="Sizing example input"
                aria-describedby="inputGroup-sizing-default"
                id="inputSearchQ"
              />
              <span
                class="input-group-text"
                id="inputGroup-sizing-default"
                title="Recharcher par le numéro de suivi ou par la siret"
              >
                <i class="fa-solid fa-magnifying-glass"></i>
              </span>
            </div>
          </div>
          <button
            type="button"
            class="normal-btn px-3 py-2 rounded bg-success text-white shadow"
            data-modal-trigger="add-compnay"
            data-gole="{{ object_list_id }}"
            data-modal-targget="mg-costum-modal-1"
            onclick="open_close_GM_costum_modal(this)"
          >
            Ajouter un tag
          </button>
        </div>
        <table class="table">
          <thead>
            <tr style="font-size: 0.8rem">
              <th>Nom<br />Nombre d'articles</th>
              <th>Dates</th>
              <th>Action</th>
            </tr>
          </thead>
          <tbody
            class="table-group-divider"
            id="tags-section-table"
            style="font-size: 0.8rem"
          >
            {% for tag in tags %}
            <tr id="tag-{{tag.id}}">
              <td>
                <a href="{% url 'get_article_by_tag' tag.id %}">#{{ tag.name }}</a><br>
                <span>{{ tag.article_count }}</span>
              </td>
              <td>
                <span class="one-ligne-text">{{ tag.created_at }}</span
                ><br /><span class="one-ligne-text">{{ tag.updated_at }}</span>
              </td>
              <td>
                <button
                  data-modal-targget="mg-costum-modal-delete-tag-{{tag.id}}"
                  onclick="open_close_GM_costum_modal(this)"
                  type="button"
                  class="normal-btn rounded shadow py-1 px-2 bg-success text-white mt-2"
                >
                  Supprimer
                </button>
                <button
                  data-modal-targget="mg-costum-modal-edit-tag-{{tag.id}}"
                  onclick="open_close_GM_costum_modal(this)"
                  type="button"
                  class="normal-btn rounded shadow py-1 px-2 bg-danger text-white mt-2"
                >
                  Modifier
                </button>
              </td>
            </tr>
            {% endfor %}
          </tbody>
        </table>
        <div class="mg-costum-modal-holder">
          <div id="mg-costum-modal-1" class="mg-costum-modal">
            <div class="mg-costum-modal-header">
              <div class="mg-costum-modal-header-content">Ajout d'un tag</div>
              <span
                id="mg-costum-modal-close-span"
                onclick="close_GM_modal_btns(this)"
                class="mg-costum-modal-header-close"
                >&times;</span
              >
            </div>
            <div class="mg-costum-modal-body">
              <form>
                <div class="mb-3">
                  <label for="mg-costum-modal-input-1" class="form-label"
                    >Nom du tag</label
                  >

                  <input
                    type="text"
                    class="form-control"
                    id="mg-costum-modal-input-1"
                  />
                </div>
              </form>
            </div>
            <div class="mg-costum-modal-footer">
              <button
                class="mg-costum-modal-footer-btn"
                onclick="close_GM_modal_btns(this)"
                id="mg-costum-modal-footer-btn-close"
              >
                Annuler
              </button>
              <button
                class="mg-costum-modal-footer-btn"
                onclick="addNewTag(this)"
                id="mg-costum-modal-footer-btn-go"
              >
                Ajouter
              </button>
            </div>
          </div>
          {% for tag in tags %}
          <div
            id="mg-costum-modal-delete-tag-{{tag.id}}"
            data-objectId="{{tag.id}}"
            class="mg-costum-modal"
          >
            <div class="mg-costum-modal-header">
              <div class="mg-costum-modal-header-content">Suppression d'un tag</div>
              <span
                id="mg-costum-modal-close-span"
                onclick="close_GM_modal_btns(this)"
                class="mg-costum-modal-header-close"
                >&times;</span
              >
            </div>
            <div class="mg-costum-modal-body">
              <p>
                Êtes vous sûr de vouloir supprimer le tag
                <span class="fw-bold ml-5">#{{tag.name}}</span> ?
              </p>
            </div>
            <div class="mg-costum-modal-footer">
              <button
                class="mg-costum-modal-footer-btn"
                onclick="close_GM_modal_btns(this)"
                id="mg-costum-modal-footer-btn-close"
              >
                Annuler
              </button>
              <button
                class="mg-costum-modal-footer-btn"
                onclick="deleteTag(this)"
                id="mg-costum-modal-footer-btn-go"
              >
                Supprimer
              </button>
            </div>
          </div>
          <div
            id="mg-costum-modal-edit-tag-{{tag.id}}"
            data-objectId="{{tag.id}}"
            class="mg-costum-modal"
          >
            <div class="mg-costum-modal-header">
              <div class="mg-costum-modal-header-content">Suppression d'un tag</div>
              <span
                id="mg-costum-modal-close-span"
                onclick="close_GM_modal_btns(this)"
                class="mg-costum-modal-header-close"
                >&times;</span
              >
            </div>
            <div class="mg-costum-modal-body">
              <form method="POST" action="{% url 'edit_tag' tag.id %}">
                {% csrf_token %}
                <div class="mb-3">
                  <label for="mg-costum-modal-input-tag-{{ tag.id }}-edit" class="form-label">Nom du tag</label>

                  <input type="text" value="{{ tag.name }}" class="form-control" name="new_name" id="mg-costum-modal-input-tag-{{ tag.id }}-edit">
                </div>

            </div>
            <div class="mg-costum-modal-footer">
              <button
                class="mg-costum-modal-footer-btn"
                onclick="close_GM_modal_btns(this)"
                id="mg-costum-modal-footer-btn-close"
              >
                Annuler
              </button>
              <button
                class="mg-costum-modal-footer-btn"
                type="submit"
                id="mg-costum-modal-footer-btn-go"
                onclick="submitForm(this)"
              >
                Modifier
              </button>
            </form>
            </div>
          </div>
          {% endfor %}
        </div>
      </section>
      <section id="types-section" class="all-others-section types">
        <p class="text-center fs-4 mt-3">Liste des types d'articles</p>
        <div class="sort">
          <div class="search">
            <div class="input-group">
              <input
                placeholder="Recharcher ..."
                type="text"
                class="form-control px-2"
                aria-label="Sizing example input"
                aria-describedby="inputGroup-sizing-default"
                id="inputSearchQ"
              />
              <span
                class="input-group-text"
                id="inputGroup-sizing-default"
                title="Recharcher par le numéro de suivi ou par la siret"
              >
                <i class="fa-solid fa-magnifying-glass"></i>
              </span>
            </div>
          </div>
          <button
            type="button"
            class="normal-btn px-3 py-2 rounded bg-success text-white shadow"
            data-modal-trigger="add-compnay"
            data-gole="{{ object_list_id }}"
            data-modal-targget="mg-costum-modal-2"
            onclick="open_close_GM_costum_modal(this)"
          >
            Ajouter un type
          </button>
        </div>
        <table class="table">
          <thead>
            <tr style="font-size: 0.8rem">
              <th>Nom<br />Nombre d'articles</th>
              <th>Dates</th>
              <th>Action</th>
            </tr>
          </thead>
          <tbody
            class="table-group-divider"
            id="types-section-table"
            style="font-size: 0.8rem"
          >
            {% for type in types %}
            <tr id="type-{{ type.id }}">
              <td>
                <a href="{% url 'list_article_with_type' type.id %}">{{ type.name }}</a>
                <!-- <span>{{ type.article_count }}</span> -->
              </td>
              <td>
                <span class="one-ligne-text">{{ type.created_at }}</span
                ><br /><span class="one-ligne-text">{{ type.updated_at }}</span>
              </td>
              <td>
                <button
                  type="button"
                  data-modal-targget="mg-costum-modal-delete-type-{{type.id}}"
                  onclick="open_close_GM_costum_modal(this)"
                  class="normal-btn rounded shadow py-1 px-2 bg-success text-white mt-2"
                >
                  Supprimer
                </button>
                <button
                  data-modal-targget="mg-costum-modal-edit-type-{{type.id}}"
                  onclick="open_close_GM_costum_modal(this)"
                  type="button"
                  class="normal-btn rounded shadow py-1 px-2 bg-danger text-white mt-2"
                >
                  Modifier
                </button>
              </td>
            </tr>
            {% endfor %}
          </tbody>
        </table>
        <div class="mg-costum-modal-holder">
          <div id="mg-costum-modal-2" class="mg-costum-modal">
            <div class="mg-costum-modal-header">
              <div class="mg-costum-modal-header-content">
                Ajout d'un type d'articles
              </div>
              <span
                id="mg-costum-modal-close-span"
                onclick="close_GM_modal_btns(this)"
                class="mg-costum-modal-header-close"
                >&times;</span
              >
            </div>
            <div class="mg-costum-modal-body">
              <form>
                <div class="mb-3">
                  <label for="mg-costum-modal-input-2" class="form-label"
                    >Nom du type
                  </label>
                  <input
                    type="text"
                    class="form-control"
                    id="mg-costum-modal-input-2"
                  />
                </div>
              </form>
            </div>
            <div class="mg-costum-modal-footer">
              <button
                class="mg-costum-modal-footer-btn"
                onclick="close_GM_modal_btns(this)"
                id="mg-costum-modal-footer-btn-close"
              >
                Annuler
              </button>
              <button
                class="mg-costum-modal-footer-btn"
                id="mg-costum-modal-footer-btn-go"
                onclick="addNewtype(this)"
              >
                Ajouter
              </button>
            </div>
          </div>

          {% for type in types %}
          <div
            id="mg-costum-modal-delete-type-{{type.id}}"
            data-objectId="{{type.id}}"
            class="mg-costum-modal"
          >
            <div class="mg-costum-modal-header">
              <div class="mg-costum-modal-header-content">Suppression d'un type</div>
              <span
                id="mg-costum-modal-close-span"
                onclick="close_GM_modal_btns(this)"
                class="mg-costum-modal-header-close"
                >&times;</span
              >
            </div>
            <div class="mg-costum-modal-body">
              <p>
                Êtes vous sûr de vouloir supprimer le type
                <span class="fw-bold ml-5">{{type.name}}</span> ?
              </p>
            </div>
            <div class="mg-costum-modal-footer">
              <button
                class="mg-costum-modal-footer-btn"
                onclick="close_GM_modal_btns(this)"
                id="mg-costum-modal-footer-btn-close"
              >
                Annuler
              </button>
              <button
                class="mg-costum-modal-footer-btn"
                onclick="deleteType(this)"
                id="mg-costum-modal-footer-btn-go"
              >
                Supprimer
              </button>
            </div>
          </div>
          <div
            id="mg-costum-modal-edit-type-{{type.id}}"
            data-objectId="{{type.id}}"
            class="mg-costum-modal"
          >
            <div class="mg-costum-modal-header">
              <div class="mg-costum-modal-header-content">Suppression d'un type</div>
              <span
                id="mg-costum-modal-close-span"
                onclick="close_GM_modal_btns(this)"
                class="mg-costum-modal-header-close"
                >&times;</span
              >
            </div>
            <div class="mg-costum-modal-body">
              <form method="POST" action="{% url 'edit_type' type.id %}">
                {% csrf_token %}
                <div class="mb-3">
                  <label for="mg-costum-modal-input-type-{{ type.id }}-edit" class="form-label">Nom du type</label>

                  <input type="text" value="{{ type.name }}" class="form-control" name="new_name" id="mg-costum-modal-input-type-{{ type.id }}-edit">
                </div>

            </div>
            <div class="mg-costum-modal-footer">
              <button
                class="mg-costum-modal-footer-btn"
                onclick="close_GM_modal_btns(this)"
                id="mg-costum-modal-footer-btn-close"
              >
                Annuler
              </button>
              <button
                class="mg-costum-modal-footer-btn"
                type="submit"
                id="mg-costum-modal-footer-btn-go"
                onclick="submitForm(this)"
              >
                Modifier
              </button>
            </form>
            </div>
          </div>

          {% endfor %}


        </div>
      </section>
      <section id="companies-section" class="all-others-section companies">
        <p class="text-center fs-4 mt-3">Liste des entreprises</p>
        <div class="sort">
          <div class="search">
            <div class="input-group">
              <input
                placeholder="Recharcher ..."
                type="text"
                class="form-control px-2"
                aria-label="Sizing example input"
                aria-describedby="inputGroup-sizing-default"
                id="inputSearchQ"
              />
              <span
                class="input-group-text"
                id="inputGroup-sizing-default"
                title="Recharcher par le numéro de suivi ou par la siret"
              >
                <i class="fa-solid fa-magnifying-glass"></i>
              </span>
            </div>
          </div>
          <button
            type="button"
            class="normal-btn px-3 py-2 rounded bg-success text-white shadow"
            data-modal-trigger="add-compnay"
            data-modal-targget="mg-costum-modal-3"
            onclick="open_close_GM_costum_modal(this)"
          >
            Ajouter une entreprise
          </button>
        </div>
        <table class="table">
          <thead>
            <tr style="font-size: 0.8rem">
              <th>Nom<br />URL</th>
              <th>Dates</th>
              <th>Action</th>
            </tr>
          </thead>
          <tbody
            class="table-group-divider"
            id="compnay-section-table"
            style="font-size: 0.8rem"
          >
            {% for compnay in companies %}
            <tr id="compnay-{{compnay.id}}" data-objectId="compnay-{{compnay.id}}">
              <td>
                <a href="{% url 'get_article_by_compnay' compnay.id %}">{{ compnay.name }}</a><br />
                <snap
                  class="fake-link"
                  onclick='window.open("{{ compnay.site_url }}", "_blank");'
                  >{{ compnay.get_site_url }}</snap
                >
              </td>
              <td>
                <span class="one-ligne-text">{{ compnay.created_at }}</span
                ><br /><span class="one-ligne-text"
                  >{{ compnay.updated_at }}</span
                >
              </td>
              <td>
                <button
                  data-modal-targget="mg-costum-modal-delete-compnay-{{compnay.id}}"
                  onclick="open_close_GM_costum_modal(this)"
                  type="button"
                  class="normal-btn rounded shadow py-1 px-2 bg-success text-white mt-2"
                  >
                  Supprimer
                </button>
                <button
                  data-modal-targget="mg-costum-modal-edit-compnay-{{compnay.id}}"
                  onclick="open_close_GM_costum_modal(this)"
                type="button"
                  class="normal-btn rounded shadow py-1 px-2 bg-danger text-white mt-2"
                >
                  Modifier
                </button>
              </td>
            </tr>
            {% endfor %}
          </tbody>
        </table>
        <div class="mg-costum-modal-holder">
          <div id="mg-costum-modal-3" class="mg-costum-modal">
            <div class="mg-costum-modal-header">
              <div class="mg-costum-modal-header-content">
                Ajout d'une entreprise
              </div>
              <span
                id="mg-costum-modal-close-span"
                onclick="close_GM_modal_btns(this)"
                class="mg-costum-modal-header-close"
                >&times;</span
              >
            </div>
            <div class="mg-costum-modal-body">
              <form>
                <div class="mb-3">
                  <label for="mg-costum-modal-input-3" class="form-label"
                    >Nom de l'entreprise</label
                  >
                  <input
                    type="text"
                    class="form-control"
                    id="mg-costum-modal-input-3"
                  />
                </div>
                <div class="mb-3">
                  <label for="mg-costum-modal-input-4" class="form-label"
                    >URL de l'entreprise</label
                  >
                  <input
                    type="url"
                    class="form-control"
                    id="mg-costum-modal-input-4"
                  />
                </div>
              </form>
            </div>
            <div class="mg-costum-modal-footer">
              <button
                class="mg-costum-modal-footer-btn"
                onclick="close_GM_modal_btns(this)"
                id="mg-costum-modal-footer-btn-close"
              >
                Annuler
              </button>
              <button
                class="mg-costum-modal-footer-btn"
                id="mg-costum-modal-footer-btn-go"
                onclick="addNewCompnay(this)"
              >
                Ajouter
              </button>
            </div>
          </div>
          {% for compnay in companies %}
          <div
            id="mg-costum-modal-delete-compnay-{{compnay.id}}"
            data-objectId="{{compnay.id}}"
            class="mg-costum-modal"
          >
            <div class="mg-costum-modal-header">
              <div class="mg-costum-modal-header-content">Suppression d'une entreprise</div>
              <span
                id="mg-costum-modal-close-span"
                onclick="close_GM_modal_btns(this)"
                class="mg-costum-modal-header-close"
                >&times;</span
              >
            </div>
            <div class="mg-costum-modal-body">
              <p>
                Êtes vous sûr de vouloir supprimer l'entreprise
                <span class="fw-bold ml-5">{{compnay.name}}</span> ?
              </p>
            </div>
            <div class="mg-costum-modal-footer">
              <button
                class="mg-costum-modal-footer-btn"
                onclick="close_GM_modal_btns(this)"
                id="mg-costum-modal-footer-btn-close"
              >
                Annuler
              </button>
              <button
                class="mg-costum-modal-footer-btn"
                onclick="deleteCpmonay(this)"
                id="mg-costum-modal-footer-btn-go"
              >
                Supprimer
              </button>
            </div>
          </div>


          <div
          id="mg-costum-modal-edit-compnay-{{compnay.id}}"
          data-objectId="{{compnay.id}}"
          class="mg-costum-modal"
        >
          <div class="mg-costum-modal-header">
            <div class="mg-costum-modal-header-content">Suppression d'une entreprise</div>
            <span
              id="mg-costum-modal-close-span"
              onclick="close_GM_modal_btns(this)"
              class="mg-costum-modal-header-close"
              >&times;</span
            >
          </div>
          <div class="mg-costum-modal-body">
            <form method="POST" action="{% url 'edit_company' compnay.id %}">
              {% csrf_token %}
              <div class="mb-3">
                <label for="mg-costum-modal-input-compnay-{{ compnay.id }}-edit-name" class="form-label">Nom de l'entreprise :</label>

                <input type="text" value="{{ compnay.name }}" class="form-control" name="new_name" id="mg-costum-modal-input-compnay-{{ compnay.id }}-edit-name">
              </div>
              <div class="mb-3">
                <label for="mg-costum-modal-input-compnay-{{ compnay.id }}-edit-url" class="form-label">URL :</label>

                <input type="text" value="{{ compnay.site_url }}" class="form-control" name="site_url" id="mg-costum-modal-input-compnay-{{ compnay.id }}-edit-url">
              </div>

          </div>
          <div class="mg-costum-modal-footer">
            <button
              class="mg-costum-modal-footer-btn"
              onclick="close_GM_modal_btns(this)"
              id="mg-costum-modal-footer-btn-close"
            >
              Annuler
            </button>
            <button
              class="mg-costum-modal-footer-btn"
              type="submit"
              id="mg-costum-modal-footer-btn-go"
              onclick="submitForm(this)"
            >
              Modifier
            </button>
          </form>
          </div>
        </div>


          {% endfor %}
        </div>
      </section>
    </div>
    <section id="modals">
      <div class="modal" data-modal="add-compnay">
        <article class="content-wrapper">
          <button type="button" class="close"></button>
          <header class="modal-header">
            <h2>Ajouter une nouvelle entreprise</h2>
          </header>
          <div class="content">
            <form>
              <div class="mb-3">
                <label for="name" class="form-label">
                  Le nom de l'entreprise
                </label>
                <input
                  type="text"
                  placeholder="Ex : Google"
                  class="form-control"
                  id="add-compnay-name"
                  aria-describedby="nameHelper"
                />
              </div>
              <div class="mb-3">
                <label for="url" class="form-label">
                  Le lien vers le site officiel de l'entreprise
                </label>
                <input
                  type="url"
                  placeholder="Ex : https://google.com"
                  class="form-control"
                  id="add-compnay-url"
                  aria-describedby="urlHelper"
                />
              </div>
              <div class="mb-3">
                <p
                  id="add-compnay-errer"
                  class="errer text-danger text-center"
                ></p>
              </div>
              <div
                class="mb-3"
                style="
                  width: 100%;
                  display: flex;
                  justify-content: center;
                  align-items: center;
                  gap: 1rem;
                "
              >
                <button
                  onclick="addCompany()"
                  type="button"
                  class="btn btn-outline-primary"
                >
                  Ajouter
                </button>
              </div>
            </form>
          </div>
        </article>
      </div>
    </section>
  </div>
</div>
<script>
  const input = document.querySelector("#inputSearchQ");
  input.addEventListener("input", (e) => {
    const q = e.target.value;
    sortTableRepairForAdminWithInput(q);
  });
  async function deleteTag(btn) {
    let id = btn.parentElement.parentElement.getAttribute("data-objectId");
    const token = document.querySelector('[name="csrfmiddlewaretoken"]').value;
    await fetch(`/api/tag/id=${id}/delete`, {
      method: "POST",
      headers: {
        "Content-Type": "application/json",
        "X-CSRFToken": token,
      },
      body: JSON.stringify({}),
    })
      .then((res) => res.json())
      .then((data) => {
        if (data.code === 1) {
          const col = document.querySelector(`#tag-${id}`);
          col.remove();
          close_GM_modal_btns(btn);
        }
      })
      .catch((err) => {
        console.log(err);
      });
  }

  async function deleteType(btn){
    let id = btn.parentElement.parentElement.getAttribute("data-objectId");
    const token = document.querySelector('[name="csrfmiddlewaretoken"]').value;
    await fetch(`/api/type/id=${id}/delete`, {
      method: "POST",
      headers: {
        "Content-Type": "application/json",
        "X-CSRFToken": token,
      },
      body: JSON.stringify({}),
    })
      .then((res) => res.json())
      .then((data) => {
        if (data.code === 1) {
          const col = document.querySelector(`#type-${id}`);
          col.remove();
          close_GM_modal_btns(btn);
        }
      })
      .catch((err) => {
        console.log(err);
      });

  }

  async function deleteCpmonay(btn){
    let id = btn.parentElement.parentElement.getAttribute("data-objectId");
    const token = document.querySelector('[name="csrfmiddlewaretoken"]').value;
    await fetch(`/api/company/id=${id}/delete`, {
      method: "POST",
      headers: {
        "Content-Type": "application/json",
        "X-CSRFToken": token,
      },
      body: JSON.stringify({}),
    })
      .then((res) => res.json())
      .then((data) => {
        if (data.code === 1) {
          const col = document.querySelector(`#compnay-${id}`);
          col.remove();
          close_GM_modal_btns(btn);
        }
      })
      .catch((err) => {
        console.log(err);
      });

  }

  function submitForm(btn) {
    btn.parentElement.parentElement.submit();
  }
</script>
{% endblock main%}
